=== debian/changelog ===
bareos (24.0.8~pre17.7f796a9c2-2) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Thu, 13 Nov 2025 10:20:49 +0000
